// scan_Scanner.h: interface for the CScanner class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NSCSCANNER_H__B58FE495_5FB2_11D3_9859_00104BF5E7FA__INCLUDED_)
#define AFX_NSCSCANNER_H__B58FE495_5FB2_11D3_9859_00104BF5E7FA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CScanner  
{
public:
    //
    // Class Methods (statics)
    // 
    static CScanner* GetInstance();

    //
    // Instance Methods 
    // 
    SCAN_RESULT ScanStart();
    SCAN_RESULT ScanRead(void*	scanBuffer,
					    long	regCount,
					    long*	actCount);

    SCAN_RESULT ScanStop();

    SCAN_RESULT ScanSetParams(SCAN_PARAM_REC* paramRec,
								FN_SCAN_CALLBACK scanCB);
    SCAN_RESULT ScanGetParams(SCAN_PARAM_REC* paramRec);
    SCAN_RESULT ScanGetScanInfo(SCAN_INFO_REC* infoRec);
	SCAN_RESULT ScanGetScanHardware(SCAN_HARDWARE_REC *hardwareRec);

    SCAN_RESULT ScanGetCapability(SCAN_CAPID capId, 
								  void*   input, 
								  void*   output,
                                  long*   numOutputElements);

        
    void InitScanner(HANDLE hModule);

    virtual ~CScanner();

protected:
	CScanner();

private:
    //
    // Methods 
    // 
    void CopyCapVectorToArray(CAP_CONTAINER& container,
                              int *outArray,
                              long *numOutputElements);

    void CopyPixelTypesToArray(int* output, long *numOutputElements);

	SCAN_RESULT CopyPixelDepthsToArray(	int pixelType, 
                                        int* outArray, 
                                        long* numOutputElements);
    
//	SCAN_RESULT  PreloadScanImage();

    bool InitializeScanParams();
    bool InitializeCapabilities();
    bool InitializeScanInfo();

    //
    // Local Data 
    //
    // The instance handle for this module    
    HINSTANCE           m_hModule;

    bool                m_scanning;             // Simple two-state state machine 
    
    // capability containers
    CAP_CONTAINER       m_capHResolutions;
    CAP_CONTAINER       m_capVResolutions;
    PIXELTYPE_CONTAINER m_capPixelTypes;

    // Intermediate scan state variables 
    int                 m_nTotalRows;
    int                 m_nRowsCopied;
    BITMAPINFOHEADER*   m_pHeader;
    BYTE *              m_pImageData;
    BYTE *              m_pCurrentLine;
    DWORD               m_dwLineSize;

    
    //
    // Statics 
    //
    static CScanner* s_theInstance;

};

#endif // !defined(AFX_NSCSCANNER_H__B58FE495_5FB2_11D3_9859_00104BF5E7FA__INCLUDED_)
