/*******************************************************************************
FILE        : Twain_CapHolder.h
REVISION    : 1.0
DATE        : 9/12/99

DESCRIPTION :

The Capability container has the currently actice set of capability objects
Each capability object handles all messages for that particulat capability
This class is a singleton class and can be accessed using standard 
singleton syntax and semantics 

Copyright (c) 1999 - National Semiconductor Ltd - All rights reserved
*******************************************************************************/
#if !defined(AFX_TWAIN_CAPCONTAINER_H__518E6C21_691E_11D3_9859_00104BF5E7FA__INCLUDED_)
#define AFX_TWAIN_CAPCONTAINER_H__518E6C21_691E_11D3_9859_00104BF5E7FA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Twain_Singleton.h"
#include "Twain_CapBase.h"

typedef map<TW_UINT16, CCapBase*>   CAP_MAP;
typedef CAP_MAP::iterator           CAP_ITERATOR;

class CCapHolder  : public CSingleton<CCapHolder>
{
public:
	CCapHolder();
	virtual ~CCapHolder();

    TW_UINT16 HandleCapabilityMsg(PTWMSG);
    
    void LoadCapabilities();
    void UnloadCapabilities();
    
    void GetSupportedCapList(vector<TW_UINT16>& capIDs);
    bool GetCapObject(TW_UINT16 capID, CCapBase*& capObject);

private:
    CAP_MAP m_capabilities;

};

#endif // !defined(AFX_TWAIN_CAPCONTAINER_H__518E6C21_691E_11D3_9859_00104BF5E7FA__INCLUDED_)


