/*******************************************************************************
FILE        : Twain_GenCaps.h
REVISION    : 1.0
DATE        : 9/12/99

DESCRIPTION :

This file contains the definition of all the general capability handling
classes. 

Copyright (c) 1999 - National Semiconductor Ltd - All rights reserved
*******************************************************************************/
#ifndef _TWAIN_GENCAPS_H__
#define _TWAIN_GENCAPS_H__

#include "Twain_CapImplementation.h"

class CCapXferCount : public CCapImplementation<TW_INT16>
{
public:
    CCapXferCount();

    TW_UINT16 GetCapID(){return CAP_XFERCOUNT;} 
    string    GetCapName(){return string("CAP_XFERCOUNT");}

protected:
    TW_INT32   GetSupportedCaps(){return (  TWQC_GET | 
                                            TWQC_SET | 
                                            TWQC_GETDEFAULT | 
                                            TWQC_GETCURRENT | 
                                            TWQC_RESET) ; }

    TW_INT32  GetItemType(){return TWTY_INT16;}

    // Overridden handlers for the supported Cap operations 
    TW_UINT16 HandleGetCapValues(pTW_CAPABILITY);
    TW_UINT16 HandleGetCurrentCap(pTW_CAPABILITY);
    TW_UINT16 HandleGetDefaultCap(pTW_CAPABILITY);
    TW_UINT16 HandleResetCap(pTW_CAPABILITY);
    TW_UINT16 HandleSetCap (pTW_CAPABILITY);

};

class CCapUIControllable : public CCapImplementation<TW_BOOL>
{
public:
    CCapUIControllable();

    TW_UINT16 GetCapID(){ return CAP_UICONTROLLABLE;}
    string    GetCapName(){return string("CAP_UICONTROLLABLE");}

protected:
    TW_INT32 GetSupportedCaps(){ return (TWQC_GET);}
    TW_INT32  GetItemType(){return TWTY_BOOL;}

    // Overridden handlers for the supported Cap operations 
    TW_UINT16 HandleGetCapValues(pTW_CAPABILITY pCapability);
};

class CCapDeviceOnline : public CCapImplementation<TW_BOOL>
{
public:
    CCapDeviceOnline();

    TW_UINT16 GetCapID(){ return CAP_DEVICEONLINE;}
    string    GetCapName(){return string("CAP_DEVICEONLINE");}

protected:
    TW_INT32    GetSupportedCaps(){ return (TWQC_GET);}
    TW_INT32  GetItemType(){return TWTY_BOOL;}

    // Overridden handlers for the supported Cap operations 
    TW_UINT16 HandleGetCapValues(pTW_CAPABILITY pCapability);

};

class CCapSupportedCaps : public CCapImplementation<TW_UINT16>
{
public:
    CCapSupportedCaps();

    TW_UINT16 GetCapID(){return CAP_SUPPORTEDCAPS;} 
    string    GetCapName(){return string("CAP_SUPPORTEDCAPS");}

protected:
    TW_INT32   GetSupportedCaps(){return (  TWQC_GET | 
                                            TWQC_GETDEFAULT | 
                                            TWQC_GETCURRENT ) ; }

    TW_INT32  GetItemType(){return TWTY_UINT16;}

    // Overridden handlers for the supported Cap operations 
    TW_UINT16 HandleGetCapValues(pTW_CAPABILITY);
    TW_UINT16 HandleGetCurrentCap(pTW_CAPABILITY);
    TW_UINT16 HandleGetDefaultCap(pTW_CAPABILITY);
};

#endif // _TWAIN_GENCAPS_H__