/*******************************************************************************
FILE        : Twain_Types.h
REVISION    : 1.0
DATE        : 9/12/99

DESCRIPTION :

Structures and other data types and definitions commmon to multiple files
in the TWAIN source module are defined here

Copyright (c) 1999 - National Semiconductor Ltd - All rights reserved
*******************************************************************************/

#ifndef _TWAIN_TYPES_H__
#define _TWAIN_TYPES_H__
/*******************************************************************************
Constants
*******************************************************************************/
/* Source Version */
#define VERSION_MAJOR       0
#define VERSION_MINOR       1

/*******************************************************************************
Structures 
*******************************************************************************/
// internal structure to store TW messages
typedef struct
{
   pTW_IDENTITY  pSrc;
   TW_UINT32     DG;
   TW_UINT16     DAT;
   TW_UINT16     MSG;
   TW_MEMREF     pData;
} TWMSG, FAR * PTWMSG;


// This struct is used to dispatch to functions to handle the
// various structures that need to be filled in.  It could be
// extended to check the Message field as well.
typedef struct 
{
   TW_UINT16   ID;                  // Either the struct id or msg id
   TW_UINT16   (*pFunc)(PTWMSG);       // Pointer to fnt which processes msg
} MAPPER, * PMAPPER;



#endif // _TWAIN_TYPES_H__