/*******************************************************************************
FILE        : Twain_Utility.h
REVISION    : 1.0
DATE        : 9/9/99

DESCRIPTION :

Defines the interface for the utility functions used in this module

Copyright (c) 1999 - National Semiconductor Ltd - All rights reserved
*******************************************************************************/
#ifndef _TWAIN_UTILITY_H__
#define _TWAIN_UTILITY_H__

TW_FIX32 FloatToFIX32 (float floater);
float FIX32ToFloat (TW_FIX32 fix32);


// DIB Support routines
TWAIN_RESULT AllocateScanDib(   HANDLE*  hDib,
                                int*    bytesToScan,
                                BYTE**  pDataBytes);

void InitializeColorTable(int colorTableEntries, LPBYTE lpColorTable);
UINT ComputePaletteSize(int nBitCount);
int GetImageBitDepth(int scanBitDepth);
void SaveBitmap(HGLOBAL _hDIB, LPCSTR pszFileName);
TWAIN_RESULT InvertDIB(HGLOBAL hDibHandle);

string GetMsgName(PTWMSG pTWMsg);
/*******************************************************************************
Core functions used to implemented various debug macros
*******************************************************************************/
#ifdef _DEBUG 

void DebugTraceMessage(LPCSTR lpszFormat, ...);
BOOL TriggerAssertionFailed(LPCSTR lpszFileName, int nLine);

/*
*	Debug version, all macros enabled
*/
#define TRACE DebugTraceMessage

#define ASSERT(cond) if(!(cond)) \
                        if(TriggerAssertionFailed(__FILE__, __LINE__)) \
                            _asm {int 3}

#define HALTCOND(cond) if(!(cond)) _asm {int 3 }

#define VERIFY(cond) ASSERT(cond)

#else //_DEBUG 

/*
*	Release version, all macros disabled
*/
#define TRACE

#define ASSERT(cond)
#define HALTCOND(cond)
#define VERIFY(cond) cond

#endif //_DEBUG 

#endif // _TWAIN_UTILITY_H__
