/*******************************************************************************
FILE        : UI_LM983x.cpp
REVISION    : X.X
DATE        : 10/26/99

DESCRIPTION : Main user interface code


WRITTEN BY	: Steven W. Roth (swroth@grasshut.com / swroth@kionet.com)

Class or Function set description - "Implementation View"

Copyright (c) 1999-2002 - National Semiconductor Corp - All rights reserved
*******************************************************************************/


#include "stdafx.h"
#include "UI_LM983x.h"
#include "UI_ScanDialog.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CUI_LM983xApp

BEGIN_MESSAGE_MAP(CUI_LM983xApp, CWinApp)
	//{{AFX_MSG_MAP(CUI_LM983xApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUI_LM983xApp construction

CUI_LM983xApp::CUI_LM983xApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CUI_LM983xApp object

CUI_LM983xApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CUI_LM983xApp initialization

BOOL CUI_LM983xApp::InitInstance()
{
	// Register all OLE server (factories) as running.  This enables the
	//  OLE libraries to create objects from other applications.
	COleObjectFactory::RegisterAll();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Special entry points required for inproc servers

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return AfxDllGetClassObject(rclsid, riid, ppv);
}

STDAPI DllCanUnloadNow(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return AfxDllCanUnloadNow();
}

// by exporting DllRegisterServer, you can use regsvr.exe
STDAPI DllRegisterServer(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	COleObjectFactory::UpdateRegistryAll();
	return S_OK;
}


#ifdef __cplusplus
extern "C" {
#endif
/*******************************************************************************
DESCRIPTION:	UIActivate is glue into the user interface activate logic

PARAMETERS:
				open	Contains TRUE/FALSE to show or hide the interface
RETURN VALUE:
				TWAIN_OK if success, else TWAIN_ERROR if failure.
*******************************************************************************/
TWAIN_RESULT UIActivate(BOOL open)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	if( open )
		return( CScanDialog::OpenScanDialog() ? TWAIN_OK : TWAIN_ERROR );
	else
		return( CScanDialog::CloseScanDialog() ? TWAIN_OK : TWAIN_ERROR );
}

/*******************************************************************************
DESCRIPTION:	UIHandleMessage is glue into the user interface message queue

PARAMETERS:
				MSG - See MFC documentation
RETURN VALUE:
				TWAIN_RESULT passed back
*******************************************************************************/
TWAIN_RESULT UIHandleMessage(MSG *pMsg)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
    // [Vicky] 
    // Pump this message through the MFC message system
    // using PretranslateMessage
    if (AfxGetApp()->PreTranslateMessage(pMsg))
        return TWAIN_OK;

	return TWAIN_UNKNOWN_MSG;;
}

/*******************************************************************************
DESCRIPTION:	UICallBack is glue into the CallBack function of the user
				interface dialog.

PARAMETERS:
				none
RETURN VALUE:
				TWAIN_RESULT passed back from the CallBack call
*******************************************************************************/
TWAIN_RESULT UICallback(BOOL check_messages)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return( g_ScanDialog->CallBack(check_messages));
}

/*******************************************************************************
DESCRIPTION:	UIEndScan is glue into the EndScan function of the user
				interface dialog.

PARAMETERS:
				tResult contains the TWAIN_RESULT of the scan.
RETURN VALUE:
				none
*******************************************************************************/
void UIEndScan( TWAIN_RESULT tResult )
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	g_ScanDialog->EndScan( tResult );
}

#ifdef __cplusplus
}
#endif
